/*
  Ŀ
   Ejemplo1.c                                                             
                                                                          
   Ejemplo de uso de la libreria 'palette.h' para el manejo de los        
   colores. En este ejemplo se hace un fundido de una paleta a negro.     
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  ] Bizarre inc. [ de Compiler SoftWare.          
  1997 C.S.
*/
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include "mode13h.h"
#include "ints.h"
#include "palette.h"

void PonPant (unsigned char *);  /* Coloca la imagen en pantalla */

void main()
{

	cprintf ("\r\n\r\n - Programa que realiza un fundido a negro de una imagen utilizando      ");
	cprintf ("\r\n las funciones de la libreria 'palette.h'.   \r\n");
	cprintf ("\r\n Nota : Requiere el fichero 'rose.scr'                                    ");
	cprintf ("\r\n\r\n  Pulse una tecla para continuar . . .");
	cprintf ("\r\n\r\n ] Bizarre inc. [  de Compiler Soft.");

	getch();

	SetVideoMode ( 0x13 );
	PonPant ("rose.scr");
	getch();
	FadeOut();
	SetVideoMode ( 3 );
}

/**************************  Funciones **********************************/

void PonPant (unsigned char *nombre)
{
   FILE *fich;
   unsigned int x, y;
   unsigned char paleta[768], linea[320];

   fich = fopen (nombre, "rb");

   if( fich == NULL )
	{
	  SetVideoMode ( 3 );
	  cprintf ("\r\nError abriendo fichero\r\n");
	  exit(1);
	}

     fseek (fich, 0, 0);
     fread (paleta, 768, 1, fich);

     SetPalette (paleta);

   for (y=0;y<200;y++)
   {
     fread (linea, 320, 1, fich);
     for (x=0;x<320;x++) PutPixel (x, y, linea[x]);
   }
}
