/*
  Ŀ
   Ejemplo3.c                                                             
                                                                          
   Ejemplo para notar la diferencia entre una imagen con una paleta que   
   no le corresponde y la misma imagen con su propia paleta.              
   Como se puede observar, aunque se cambien los colores la imagen no se  
   ve afectada (sigue siendo la imagen de la rosa), pero con otros        
   colores.                                                               
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  ] Bizarre inc. [ de Compiler SoftWare.          
  1997 C.S.
*/
#include <conio.h>
#include <stdlib.h>   /* Para usar la funcin exit() */
#include <stdio.h>
#include "mode13h.h"
#include "ints.h"
#include "palette.h"

void PonPant (unsigned char *);  /* Pone la imagen en pantalla y guarda */
				 /* la paleta en un array               */

unsigned char paleta[768];       /* Array para la paleta                */

void main (void)
{
cprintf ("\r\nPrograma para ver la diferencia entre una paleta por defecto");
cprintf ("\r\ny una paleta especifica para la imagen \r\n\r\n");
cprintf ("\r\n- Primero se ver una imagen con la paleta por defecto\r\n");
cprintf ("- Imagen original con su paleta correspondiente\r\n");
cprintf ("\r\n\r\n Nota : Requiere el fichero 'rose.scr'");
cprintf ("\r\n Pulse una tecla para continuar . . .");
cprintf ("\r\n\r\n ] Bizarre inc. [  de Compiler Soft.");

getch();

     SetVideoMode ( 0x13 );

     PonPant ("rose.scr");
     getch();
     SetPalette (paleta);
     getch();

     SetVideoMode ( 3 );
}
/*************** Funciones ********************************************/

void PonPant (unsigned char *nombre)
{
   FILE *fich;
   unsigned int x, y;
   unsigned char linea[320];

   fich = fopen (nombre, "rb");

   if( fich == NULL )
	{
	asm {
	  mov ax, 0x3
	  int 0x10
	}
	  cprintf ("\r\nError abriendo fichero\r\n");
	  exit(1);
	}

   fseek (fich, 0, 0);
   fread (paleta, 768, 1, fich);

   for (y=0;y<200;y++)
   {
     fread (linea, 320, 1, fich);
     for (x=0;x<320;x++) PutPixel (x, y, linea[x]);
   }
}
