/*
  Ŀ
   Ejemplo6.c                                                             
                                                                          
   Ejemplo donde se muestran varias rutinas de la libreria 'palette.h'    
   como la rotacin de la paleta en los dos sentidos de giro, el negativo 
   de la imagen o pasar la paleta a escala de grises. Estos dos ltimos   
   ejemplos no estn explicados en el artculo, pero en la libreria se    
   puede deducir el trabajo que realiza cada uno.                         
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  ] Bizarre inc. [ de Compiler SoftWare.          
  1997 C.S.
*/
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include "mode13h.h"
#include "ints.h"
#include "palette.h"

void PonPant (unsigned char *);  /* Coloca la imagen en pantalla */

unsigned char paleta[768];

void main()
{
 int x;

	cprintf ("\r\n\r\n - Este programa hace varios efectos sobre la paleta. Despus de dibujar");
	cprintf ("\r\n la imagen en la pantalla y poner su paleta correspondiente, hace: 	");
	cprintf ("\r\n         1.- Un negativo de la paleta");
	cprintf ("\r\n         2.- Pasa la paleta a escala de grises");
	cprintf ("\r\n         3.- Vuelve a hacer un negativo, pero con la paleta en grises");
	cprintf ("\r\n         4.- Rota la paleta hacia derechas y luego a izquierdas");
	cprintf ("\r\n Nota : Requiere el fichero 'rose.scr'                                    ");
	cprintf ("\r\n\r\n  Pulse una tecla para continuar . . .");
	cprintf ("\r\n\r\n ] Bizarre inc. [  de Compiler Soft.");

	getch();

	SetVideoMode ( 0x13 );

	PonPant ("rose.scr");
	getch();
	NegativePalette (paleta);
	getch();
	GreyPalette (paleta);
	getch();
	NegativePalette (paleta);
	getch();
	while (!kbhit()) RotatePaletteLeft (paleta);
	getch();
	while (!kbhit()) RotatePaletteRight(paleta);
	getch();

	SetVideoMode ( 3 );
}

/**************************  Funciones **********************************/

void PonPant (unsigned char *nombre)
{
   FILE *fich;
   unsigned int x, y;
   unsigned char  linea[320];

   fich = fopen (nombre, "rb");

   if( fich == NULL )
	{
	asm {
	    mov ax, 0x3
	    int 0x10
	    }
	  cprintf ("\r\nError abriendo fichero\r\n");
	  exit(1);
	}

     fseek (fich, 0, 0);
     fread (paleta, 768, 1, fich);

     SetPalette (paleta);

   for (y=0;y<200;y++)
   {
     fread (linea, 320, 1, fich);
     for (x=0;x<320;x++) PutPixel (x, y, linea[x]);
   }
}
