/*
  Ŀ
   Ejemplo4.c                                                             
                                                                          
   Ejemplo sobre la funcin FadeTo() que hace una transaccin como la del 
   fundido, pero entre dos paletas. En este ejemplo se pasa de una imagen 
   con sus colores correspondientes a la misma imagen, pero con la paleta 
   en gama de grises, y despus de esta gama de grises otra vez a los     
   primeros colores.                                                      
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  ] Bizarre inc. [ de Compiler SoftWare.          
  1997 C.S.
*/
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include "mode13h.h"
#include "ints.h"
#include "palette.h" 

void PonPant (unsigned char *);  /* Coloca la imagen en pantalla */
void GreyPal (void);

unsigned char paleta[768], paleta1[768];

void main()
{
 int x;

	cprintf ("\r\n\r\n - Programa que realiza un fundido desde la paleta original hasta  la ");
	cprintf ("\r\n la paleta pasada a tono de grises, y otra vez hasta la paleta original.");
	cprintf ("\r\n Para esto se utilizan las funciones de la libreria 'palette.h'.\r\n");
	cprintf ("\r\n Nota : Requiere el fichero 'rose.scr'                                    ");
	cprintf ("\r\n\r\n  Pulse una tecla para continuar . . .");
	cprintf ("\r\n\r\n ] Bizarre inc. [  de Compiler Soft.");

	getch();

	SetVideoMode ( 0x13 );

	PonPant ("rose.scr");
	GreyPal ();
	FadeTo (paleta1);
	FadeTo (paleta);
	getch();
	SetVideoMode ( 3 );
}

/**************************  Funciones **********************************/

void PonPant (unsigned char *nombre)
{
   FILE *fich;
   unsigned int x, y;
   unsigned char  linea[320];

   fich = fopen (nombre, "rb");

   if( fich == NULL )
	{
	  SetVideoMode ( 3 );
	  cprintf ("\r\nError abriendo fichero\r\n");
	  exit(1);
	}

     fseek (fich, 0, 0);
     fread (paleta, 768, 1, fich);

     SetPalette (paleta);

   for (y=0;y<200;y++)
   {
     fread (linea, 320, 1, fich);
     for (x=0;x<320;x++) PutPixel (x, y, linea[x]);
   }
}

/*********/

void GreyPal (void)
{
  int x, y;
  int media;

  for (x=0;x<768;x+=3)
  {
     media = (paleta[x] + paleta[x+1] + paleta[x+2]) / 3;
     paleta1[x] = media;
     paleta1[x+1] = media;
     paleta1[x+2] = media;
  }
}
